var cardW = 100;
var cardH = 210;
var youNum = 3;
var images = [];
var tehuda = [];
var passNum= [];
var stage = []; 
var turnNo;
var enemy = [];
var sakusenNo;
var orders = [];
var handsCtx, stageCtx;
var $j = jQuery.noConflict();

window.onload = index;

function $js(id) { return document.getElementById(id); }

function index() {
	$js("btn1").innerHTML = "<a href='javascript:hutuu()' class='pochi'>NORMAL</a>";
	$js("btn2").innerHTML = "<a href='javascript:kitui()' class='pochi'>HARD</a>";
}
function hutuu() {
	sakusenNo = 0;
	init();
}
function kitui() {
	sakusenNo = 1;
	init();
}
function init() {
	stageCtx = $js("stageCanvas").getContext("2d");
	handsCtx = $js("handsCanvas").getContext("2d");
	stageCtx.clearRect(0,0,$js("stageCanvas").width+1,$js("stageCanvas").height+1);
	$js("handsCanvas").onmousedown = mouseHandler;
	loadCardImage(gameStart);
	$js("index").style.display = "none";
    $js("result").style.display = "none";
	$j("#stage").fadeIn();
}
function loadCardImage(onCompleted) {
	var files = [];
	var ctypes = ["s","h","d","c"];
	for (var t = 0; t < 4; t++) {
		for (var n=1; n<=13; n++) {
			var mark = ctypes[t];
			var no = "00" + n;
			no = no.substr(no.length-2,3);
			var f = "images/" + mark + no + ".png";
			files.push(f);
		}
	} 
	var num_load = 0;
	for (var i=0; i<files.length; i++) {
		var img = new Image();
		img.onload = function () {
			num_load++;
			if (num_load == files.length) {
				onCompleted();
			}
		};
		img.onerror = function() {
			alert("Failed to load file," +
					"Please reload.");
		};
		img.src = files[i];
		images[i] = img;
	}
}
function gameStart() {
	passNum = [0,0,0,0]; 
	orders = [];
	shuffleCard();
	drawCard();
	$js("pass").innerHTML = "PASS";
	turnNo = rnd(4);
	nextTurn();
}
function shuffleCard() {
	for (var i = 0; i < 52; i++) {
		stage[i] = 0;
	}
	var cards = [];
	for (var i = 0; i < 52; i++) {
		cards[i] = i;
	}
	for (var i = 51; i > 0; i--) {
		var r = rnd(i+1);
		var tmp = cards[i];
		cards[i] = cards[r];
		cards[r] = tmp;
	}
	tehuda = [];
	for (var u = 0; u < 4; u++) tehuda[u] = [];
	for (var i = 0; i < 52; i++) {
		var u = Math.floor(i % 4);
		var n = cards[i];
		if (n % 13 == 6) {
			stage[n] = 1;
			continue;
		}
		tehuda[u].push(cards[i]);
	}
	if (sakusenNo == 0) {
		tehuda[youNum].sort(function(a,b){
			return a - b;
		});
	}
}
function rnd(c) {
	return Math.floor(Math.random() * c);
}
function nextTurn(sakusenNo) {
	checkStage();
	if (checkEnd()) {
		turnNo = -1;
		drawCard();
		return;
	}
	if (turnNo != youNum) {
		if (sakusenNo != 1) comTurn01(turnNo);
		else comTurn02(turnNo);
	} else if (tehuda[youNum].length > 0) {
		drawCard();
		return;
	} 
	drawCard();
	turnNo = (turnNo + 1) % 4;
	setTimeout(nextTurn, 600);
}

function comTurn01(u) {
	var myTe = tehuda[u];
	if (myTe.length == 0) return;
	var imax = -1, vmax = -1;
	for (var i = 0; i < myTe.length; i++) {
		var no = myTe[i];
		if (!canDiscard(no)) continue;
		var n = no % 13;
		var point = rnd(3) + (7 - Math.abs(n - 6));
		if (vmax < point) {
			vmax = point;
			imax = i;
		}
	}
	if (imax < 0) {
		passNum[u]++;
		if (passNum[u] > 3) {
		dropOut(u);
		} 
		return;
	}
	var no = myTe[imax];
	stage[no] = 1;
	myTe.splice(imax, 1);
	if (myTe.length == 0) {
		orders.push(u);
	}
	checkEnd();
}
function comTurn02(u) {
	var myTe = tehuda[u];
	if (myTe.length == 0) return;

	var imax = -1, vmax = -1;
	for (var i = 0; i < myTe.length; i++) {
		var no = myTe[i];
		if (!canDiscard(no)) continue;
		var n = no % 13;
		var point = rnd(3) + (7 - Math.abs(n - 6));
		if (vmax < point) {
			vmax = point;
			imax = i;
		}
	}
	for (var t = 0; t < myTe.length; t++) {
		var no2 = myTe[t];
		if (!canDiscard(no2)) continue;
		var n2 = no2 % 13;
		if (n2 != 13 && n2 != 1) {
            for (var s = 1; s < myTe.length; s++) {
				var no3 = myTe[s];
				var n3 = no3 % 13;
				if ((n2 < 7 && (no2 - no3) == 1) || (n2 > 7 && (no3 - no2) == 1)) imax = t;
			}
		}
	}
	if (imax < 0) {
		passNum[u]++;
		if (passNum[u] > 3) {
		dropOut(u);
		} 
		return;
	}
	var no = myTe[imax];
	stage[no] = 1;
	myTe.splice(imax, 1);
	if (myTe.length == 0) {
		orders.push(u);
	}
	checkEnd();
}

function dropOut(u) {
	var p = tehuda[u];
	for (var i=0; i<p.length; i++) {
		var no = p[i];
		stage[no] = 2;
	}
	tehuda[u] = [];
}
function drawCard() {
	drawHand();
	drawStage();
	showInfo();
}
function showInfo() {
	var s = "";
	enemy[0] = ["Mr.G","<img src='images/00g.png' class='kao' width='30' height='30'>"];
	enemy[1] = ["Mr.J","<img src='images/01j.png' class='kao' width='30' height='30'>"];
	enemy[2] = ["Mr.Z","<img src='images/02z.png' class='kao' width='30' height='30'>"];
	enemy[3] = ["YOU ","<img src='images/03yo.png' class='kao' width='30' height='30'>"];
	for (var i = 0; i < 4; i++) {
		s += (turnNo == i) ? "<p><span class='turn'>" : "";
		s += (i == youNum) ? enemy[i][0]+enemy[i][1] + "&nbsp;" : enemy[i][0]+enemy[i][1] + "&nbsp;";
		var r = orders.indexOf(i);
		if (r >= 0) {
			if (r == 0) s += "&nbsp;Win";
			else if (r == 1) s += "&nbsp;2nd";
			else if (r == 2) s += "&nbsp;3rd";
			else s += "&nbsp;4th";
		} else {
			if (passNum[i] > 3) {
				s += "&nbsp;&nbsp;×";
			} else {
				s += tehuda[i].length + "&nbsp;cards&nbsp;&nbsp;pass&nbsp;";
				s += passNum[i] + "/3";
			}
		}
		s += "</span></p>";
	}
	$js("info").innerHTML = s;
}
function drawHand() {
	handsCtx.clearRect(0,0,$js("handsCanvas").width+1,$js("handsCanvas").height+1);
	handsCtx.canvas.style.visibility = 'hidden';
	handsCtx.canvas.offsetHeight;
	handsCtx.canvas.style.visibility = 'inherit';
	var p = tehuda[youNum];
	for (var i=0; i<p.length; i++) {
		var x = i * cardW;
		var c = p[i];
		handsCtx.drawImage(images[c],x,0,cardW,cardH);
	}
}
function drawStage() {
	for (var i = 0; i < 52; i++) {
		var card = stage[i];
		var x = (i % 13) * cardW;
		var y = Math.floor(i / 13) * cardH;
		if (card === 0) {
			stageCtx.strokeStyle = "RGB(192,192,192)";
			stageCtx.lineWidth = 3;
			stageCtx.strokeRect(x,y,cardW,cardH);
			continue;
		}
		stageCtx.drawImage(images[i],x,y,cardW,cardH);
	}
}
function canDiscard(no) {
	var n = no % 13;
	return (n > 6) ? (stage[no-1] === 1)
						: (stage[no+1] === 1);
}
function mouseHandler(e) {
	if (turnNo != youNum) return;
	var x = e.offsetX, y = e.offsetY;
	if (!e.hasOwnProperty('offsetX')) {
		var p = e.currentTarget;
		x = e.layerX - p.offsetLeft;
		y = e.layerY - p.offsetTop;
	}
	var myTe = tehuda[youNum];
    var z = document.body.clientWidth / 13;
	var i = Math.floor(x / z);
	var no = myTe[i];
	if (!canDiscard(no)) return;
	stage[no] = 1;
	myTe.splice(i, 1);
	if (myTe.length == 0) {
		orders.push(youNum);
	}
	turnNo = 0;
	nextTurn(); 
}
function pass() {
	if (checkEnd()) {
		report();
		return;
	}
	if (turnNo != youNum) return;
	passNum[youNum]++;
	if (passNum[youNum] > 3) {
		dropOut(youNum);
		drawCard();
	}
	turnNo = 0;
	nextTurn();
}
function checkEnd() {
	for (var i = 0; i < 52; i++) {
		if (stage[i] == 0) return false;
	}
	$js("pass").innerHTML = "RESULTS";
	return true;
}
function report() {
	var wd = sessionStorage["wData"];
	var ld = sessionStorage["lData"];
	var winData = 0;
	var losData = 0;
	if (wd != null || ld != null) {
		winData = JSON.parse(sessionStorage.getItem("wData"));
		losData = JSON.parse(sessionStorage.getItem("lData"));
	}
    if (orders[0] == youNum) {
		$js("kekka1").innerHTML = "<img src='images/youwin.png'>";
      winData++;
	} else {
		$js("kekka1").innerHTML = "<img src='images/youlose.png'>";
      losData++;
	}
	var score = "";
	var bunbo = winData + losData;
	var wPer = Math.round(winData * 100 / bunbo);
	score += "<ul><b>SCORE</b></ul>";
	score += "<ul><b>win&nbsp;&nbsp;:&emsp;" + winData + "</b></ul>";
	score += "<ul><b>lose&nbsp;:&emsp;" + losData + "</b></ul>";
	score += "<ul><b>WP : " + wPer + "%</b></ul>";
	$js("kekka2").innerHTML = score;
	sessionStorage.setItem("wData",JSON.stringify(winData));
	sessionStorage.setItem("lData",JSON.stringify(losData));
	$js("stage").style.display = "none";
	$j("#result").fadeIn("slow");
}

function checkStage() {
	for (var i = 0; i < 52; i++) {
		if (stage[i] != 2) continue;
		if (canDiscard(i)) {
			stage[i] = 1;
		}
	}
}
function restart() {
	sessionStorage.removeItem("wData");
	sessionStorage.removeItem("lData");
	window.location.reload();
}